//////////////作者:BlueprintLT//////////////////

import {world} from "@minecraft/server";

world.afterEvents.dataDrivenEntityTrigger.subscribe(lt=>{
  let {entity,eventId}=lt;
	if(entity.typeId==="lt:block_jump"){
	  switch(eventId){
	    case "sensor_initial":
	    case "sensor_for_bedrock_golem_lord":
	    case "sensor_for_nether_warlord":
  	    let vT=entity.location;
  	    let block=entity.dimension.getBlock({x:vT.x,y:vT.y-1,z:vT.z});
  	    let blockId=block.typeId;
  		  entity.runCommand(`replaceitem entity @e[type=lt:block_jump,c=1] slot.weapon.mainhand 0 ${blockId}`);
	      break;
	    case "knockback_surrounding_entities":
  	    let entitiesIn=entity.dimension.getEntities({excludeTypes:["lt:bedrock_golem_lord","lt:bedrock_golem_minion","lt:bedrock_golem_luminous","item","xp_orb","lightning_bolt","evocation_fang","tnt","arrow"],excludeFamilies:["inanimate"],location:entity.location,minDistance:0,maxDistance:1});
	      for(const entityIn of entitiesIn){
	        if(entityIn.typeId==="minecraft:player"){
	          entityIn.applyKnockback(0,0,1,2);
	        }else{
	          entityIn.applyImpulse({x:0.00,y:0.43,z:0.00});
	        }
		    }
	      break;
	    default:
	      break;
	  }
	}
});

//////////////作者:BlueprintLT//////////////////