import {world,system} from "@minecraft/server";
function CrDistance(a,b){
  const x=a.x-b.x;
  const y=a.y-b.y;
  const z=a.z-b.z;
  return Math.sqrt(x**2+y**2+z**2);
};
function CrUnitVector(v){
  const l=Math.sqrt(v.x**2+v.y**2+v.z**2);
  return {x:v.x/l,y:v.y/l,z:v.z/l};
};
world.afterEvents.dataDrivenEntityTrigger.subscribe(cr=>{
  const entity=cr.entity;
  const entityId=entity.typeId;
  const eventId=cr.eventId;
	if(entityId==="cr:oni_ninja" && eventId==="jump_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.12;
		  const vY=distance*unitV.y*0.10+0.09*distance;
		  const vZ=distance*unitV.z*0.16;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
});