import {world,system} from "@minecraft/server";
function CrDistance(a,b){
  const x=a.x-b.x;
  const y=a.y-b.y;
  const z=a.z-b.z;
  return Math.sqrt(x**2+y**2+z**2);
};
function CrUnitVector(v){
  const l=Math.sqrt(v.x**2+v.y**2+v.z**2);
  return {x:v.x/l,y:v.y/l,z:v.z/l};
};
world.afterEvents.dataDrivenEntityTrigger.subscribe(cr=>{
  const entity=cr.entity;
  const entityId=entity.typeId;
  const eventId=cr.eventId;
	if(entityId==="cr:be" && eventId==="sensor"){
	  try{
	    const v1=entity.location;
	    const v2={x:v1.x,y:v1.y-1,z:v1.z};
	    const block=entity.dimension.getBlock(v2);
	    const blockId=block.typeId;
		  entity.runCommand(`replaceitem entity @e[type=cr:be,c=1] slot.weapon.mainhand 0 ${blockId}`);
		}catch(error){}finally{};
  }
});